/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 86 "src/parse.yy"


#include "ispc.h"
#include "type.h"
#include "module.h"
#include "decl.h"
#include "expr.h"
#include "sym.h"
#include "stmt.h"
#include "util.h"

#include <stdio.h>
#include <llvm/IR/Constants.h>

using namespace ispc;

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage);
static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float", "for", "foreach", "foreach_active", "foreach_tiled",
     "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = NULL, Expr *b = NULL, Expr *e = NULL) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 145 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 15,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 16,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 17,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 18,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 19,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 20,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 21,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 22,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_PTR_OP = 23,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 24,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 25,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 26,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 27,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 28,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 29,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 30,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 31,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 32,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 33,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 34,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 35,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 36,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 37,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 38,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 39,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 40,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 41,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 42,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 43,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 44,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 45,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 46,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 47,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_INTRINSIC_CALL = 48,      /* TOKEN_INTRINSIC_CALL  */
  YYSYMBOL_TOKEN_ALLOCA = 49,              /* TOKEN_ALLOCA  */
  YYSYMBOL_TOKEN_EXTERN = 50,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 51,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 52,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 53,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 54,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 55,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_TASK = 56,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 57,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 58,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 59,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 60,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 61,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 62,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_CHAR = 63,                /* TOKEN_CHAR  */
  YYSYMBOL_TOKEN_INT = 64,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 65,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 66,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT = 67,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 68,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 69,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 70,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 71,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 72,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 73,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 74,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 75,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 76,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 77,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 78,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 79,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 80,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 81,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 82,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 83,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 84,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 85,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 86,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 87,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 88,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 89,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 90,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 91,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 92,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 93,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 94,      /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 95,           /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 96,                 /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 97,                /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 98,            /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 99,               /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 100,             /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 101,                /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 102,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 103,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 104,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 105,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 106,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 107,             /* TOKEN_ASSERT  */
  YYSYMBOL_108_ = 108,                     /* '('  */
  YYSYMBOL_109_ = 109,                     /* ')'  */
  YYSYMBOL_110_ = 110,                     /* '['  */
  YYSYMBOL_111_ = 111,                     /* ']'  */
  YYSYMBOL_112_ = 112,                     /* ','  */
  YYSYMBOL_113_ = 113,                     /* '<'  */
  YYSYMBOL_114_ = 114,                     /* '>'  */
  YYSYMBOL_115_ = 115,                     /* '.'  */
  YYSYMBOL_116_ = 116,                     /* '&'  */
  YYSYMBOL_117_ = 117,                     /* '*'  */
  YYSYMBOL_118_ = 118,                     /* '+'  */
  YYSYMBOL_119_ = 119,                     /* '-'  */
  YYSYMBOL_120_ = 120,                     /* '~'  */
  YYSYMBOL_121_ = 121,                     /* '!'  */
  YYSYMBOL_122_ = 122,                     /* '/'  */
  YYSYMBOL_123_ = 123,                     /* '%'  */
  YYSYMBOL_124_ = 124,                     /* '^'  */
  YYSYMBOL_125_ = 125,                     /* '|'  */
  YYSYMBOL_126_ = 126,                     /* '?'  */
  YYSYMBOL_127_ = 127,                     /* ':'  */
  YYSYMBOL_128_ = 128,                     /* '='  */
  YYSYMBOL_129_ = 129,                     /* ';'  */
  YYSYMBOL_130_ = 130,                     /* '{'  */
  YYSYMBOL_131_ = 131,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 132,                 /* $accept  */
  YYSYMBOL_string_constant = 133,          /* string_constant  */
  YYSYMBOL_primary_expression = 134,       /* primary_expression  */
  YYSYMBOL_launch_expression = 135,        /* launch_expression  */
  YYSYMBOL_postfix_expression = 136,       /* postfix_expression  */
  YYSYMBOL_intrinsic_name = 137,           /* intrinsic_name  */
  YYSYMBOL_intrincall_expression = 138,    /* intrincall_expression  */
  YYSYMBOL_funcall_expression = 139,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 140, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 141,         /* unary_expression  */
  YYSYMBOL_cast_expression = 142,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 143, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 144,      /* additive_expression  */
  YYSYMBOL_shift_expression = 145,         /* shift_expression  */
  YYSYMBOL_relational_expression = 146,    /* relational_expression  */
  YYSYMBOL_equality_expression = 147,      /* equality_expression  */
  YYSYMBOL_and_expression = 148,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 149,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 150,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 151,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 152,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 153,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 154,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 155, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 156,           /* new_expression  */
  YYSYMBOL_assignment_expression = 157,    /* assignment_expression  */
  YYSYMBOL_expression = 158,               /* expression  */
  YYSYMBOL_constant_expression = 159,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 160,    /* declaration_statement  */
  YYSYMBOL_declaration = 161,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 162,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 163,            /* declspec_item  */
  YYSYMBOL_declspec_list = 164,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 165,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 166,   /* declaration_specifiers  */
  YYSYMBOL_init_declarator_list = 167,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 168,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 169,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 170,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 171,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 172, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 173,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 174,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 175, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 176, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 177,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 178,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 179,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 180, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 181,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 182,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 183,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 184,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 185,          /* enumerator_list  */
  YYSYMBOL_enumerator = 186,               /* enumerator  */
  YYSYMBOL_type_qualifier = 187,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 188,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 189,               /* declarator  */
  YYSYMBOL_int_constant = 190,             /* int_constant  */
  YYSYMBOL_direct_declarator = 191,        /* direct_declarator  */
  YYSYMBOL_pointer = 192,                  /* pointer  */
  YYSYMBOL_reference = 193,                /* reference  */
  YYSYMBOL_parameter_type_list = 194,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 195,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 196,    /* parameter_declaration  */
  YYSYMBOL_type_name = 197,                /* type_name  */
  YYSYMBOL_abstract_declarator = 198,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 199, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 200,              /* initializer  */
  YYSYMBOL_initializer_list = 201,         /* initializer_list  */
  YYSYMBOL_pragma = 202,                   /* pragma  */
  YYSYMBOL_attributed_statement = 203,     /* attributed_statement  */
  YYSYMBOL_statement = 204,                /* statement  */
  YYSYMBOL_labeled_statement = 205,        /* labeled_statement  */
  YYSYMBOL_start_scope = 206,              /* start_scope  */
  YYSYMBOL_end_scope = 207,                /* end_scope  */
  YYSYMBOL_compound_statement = 208,       /* compound_statement  */
  YYSYMBOL_statement_list = 209,           /* statement_list  */
  YYSYMBOL_expression_statement = 210,     /* expression_statement  */
  YYSYMBOL_selection_statement = 211,      /* selection_statement  */
  YYSYMBOL_for_test = 212,                 /* for_test  */
  YYSYMBOL_for_init_statement = 213,       /* for_init_statement  */
  YYSYMBOL_for_scope = 214,                /* for_scope  */
  YYSYMBOL_cfor_scope = 215,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 216,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 217,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 218,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 219,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 220, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 221,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 222, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 223,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 224,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 225, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 226,      /* iteration_statement  */
  YYSYMBOL_227_1 = 227,                    /* $@1  */
  YYSYMBOL_228_2 = 228,                    /* $@2  */
  YYSYMBOL_229_3 = 229,                    /* $@3  */
  YYSYMBOL_230_4 = 230,                    /* $@4  */
  YYSYMBOL_goto_identifier = 231,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 232,           /* jump_statement  */
  YYSYMBOL_sync_statement = 233,           /* sync_statement  */
  YYSYMBOL_delete_statement = 234,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 235,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 236,          /* print_statement  */
  YYSYMBOL_assert_statement = 237,         /* assert_statement  */
  YYSYMBOL_translation_unit = 238,         /* translation_unit  */
  YYSYMBOL_external_declaration = 239,     /* external_declaration  */
  YYSYMBOL_function_definition = 240,      /* function_definition  */
  YYSYMBOL_241_5 = 241                     /* $@5  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  81
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3724

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  132
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  110
/* YYNRULES -- Number of rules.  */
#define YYNRULES  350
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  661

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   362


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,     2,     2,   123,   116,     2,
     108,   109,   117,   118,   112,   119,   115,   122,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   127,   129,
     113,   128,   114,   126,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   110,     2,   111,   124,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   130,   125,   131,   120,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   281,   281,   282,   291,   310,   314,   318,   322,   326,
     330,   334,   338,   342,   346,   350,   353,   356,   361,   362,
     366,   372,   379,   385,   392,   398,   404,   410,   417,   422,
     427,   432,   439,   445,   451,   457,   466,   467,   469,   471,
     472,   474,   476,   478,   483,   490,   506,   507,   509,   511,
     516,   517,   531,   532,   533,   535,   537,   539,   541,   543,
     545,   547,   549,   551,   553,   560,   561,   568,   569,   571,
     573,   578,   579,   581,   586,   587,   589,   594,   595,   597,
     599,   601,   606,   607,   609,   614,   615,   620,   621,   626,
     627,   632,   633,   638,   639,   644,   645,   650,   651,   652,
     656,   657,   668,   679,   703,   704,   708,   712,   719,   720,
     722,   724,   726,   728,   730,   732,   734,   736,   738,   740,
     745,   746,   751,   755,   781,   785,   792,   797,   807,   812,
     821,   828,   832,   846,   852,   862,   868,   879,   883,   889,
     907,   911,   921,   928,   942,   943,   952,   953,   954,   955,
     959,   960,   965,   966,   970,   981,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1007,  1014,
    1015,  1019,  1041,  1042,  1062,  1076,  1084,  1101,  1105,  1112,
    1126,  1131,  1132,  1133,  1134,  1215,  1222,  1236,  1244,  1247,
    1251,  1255,  1259,  1263,  1286,  1296,  1310,  1314,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1344,
    1348,  1355,  1367,  1379,  1383,  1384,  1385,  1386,  1390,  1396,
    1400,  1418,  1429,  1433,  1445,  1455,  1463,  1467,  1473,  1479,
    1490,  1498,  1502,  1509,  1518,  1526,  1530,  1539,  1546,  1563,
    1564,  1576,  1580,  1581,  1591,  1595,  1608,  1610,  1616,  1633,
    1644,  1662,  1664,  1670,  1680,  1694,  1695,  1696,  1700,  1702,
    1716,  1723,  1731,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,  1755,  1759,  1769,  1774,
    1778,  1782,  1783,  1787,  1793,  1806,  1807,  1811,  1813,  1815,
    1817,  1819,  1824,  1826,  1831,  1832,  1836,  1840,  1844,  1848,
    1852,  1859,  1863,  1870,  1874,  1878,  1882,  1889,  1893,  1900,
    1905,  1919,  1923,  1927,  1929,  1931,  1933,  1935,  1939,  1943,
    1947,  1952,  1951,  1980,  1979,  2009,  2008,  2020,  2018,  2039,
    2043,  2045,  2047,  2049,  2051,  2056,  2061,  2068,  2075,  2079,
    2086,  2093,  2094,  2095,  2099,  2100,  2101,  2106,  2112,  2117,
    2116
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT_CONSTANT",
  "TOKEN_DOUBLE_CONSTANT", "TOKEN_STRING_C_LITERAL", "TOKEN_IDENTIFIER",
  "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME", "TOKEN_PRAGMA", "TOKEN_NULL",
  "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP", "TOKEN_LEFT_OP",
  "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP", "TOKEN_EQ_OP",
  "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP", "TOKEN_MUL_ASSIGN",
  "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN", "TOKEN_ADD_ASSIGN",
  "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN", "TOKEN_RIGHT_ASSIGN",
  "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN", "TOKEN_XOR_ASSIGN",
  "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE", "TOKEN_IN",
  "TOKEN_INTRINSIC_CALL", "TOKEN_ALLOCA", "TOKEN_EXTERN", "TOKEN_EXPORT",
  "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE", "TOKEN_VECTORCALL",
  "TOKEN_TASK", "TOKEN_DECLSPEC", "TOKEN_UNIFORM", "TOKEN_VARYING",
  "TOKEN_TYPEDEF", "TOKEN_SOA", "TOKEN_UNMASKED", "TOKEN_CHAR",
  "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED", "TOKEN_FLOAT",
  "TOKEN_DOUBLE", "TOKEN_INT8", "TOKEN_INT16", "TOKEN_INT64",
  "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL", "TOKEN_UINT8", "TOKEN_UINT16",
  "TOKEN_UINT", "TOKEN_UINT64", "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE",
  "TOKEN_FALSE", "TOKEN_CASE", "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE",
  "TOKEN_SWITCH", "TOKEN_WHILE", "TOKEN_DO", "TOKEN_LAUNCH",
  "TOKEN_FOREACH", "TOKEN_FOREACH_TILED", "TOKEN_FOREACH_UNIQUE",
  "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT", "TOKEN_FOR", "TOKEN_GOTO",
  "TOKEN_CONTINUE", "TOKEN_BREAK", "TOKEN_RETURN", "TOKEN_CIF",
  "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE", "TOKEN_SYNC", "TOKEN_PRINT",
  "TOKEN_ASSERT", "'('", "')'", "'['", "']'", "','", "'<'", "'>'", "'.'",
  "'&'", "'*'", "'+'", "'-'", "'~'", "'!'", "'/'", "'%'", "'^'", "'|'",
  "'?'", "':'", "'='", "';'", "'{'", "'}'", "$accept", "string_constant",
  "primary_expression", "launch_expression", "postfix_expression",
  "intrinsic_name", "intrincall_expression", "funcall_expression",
  "argument_expression_list", "unary_expression", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "and_expression",
  "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "storage_class_specifier", "type_specifier", "type_specifier_list",
  "atomic_var_type_specifier", "short_vec_specifier",
  "struct_or_union_name", "struct_or_union_and_name",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,    40,    41,
      91,    93,    44,    60,    62,    46,    38,    42,    43,    45,
     126,    33,    47,    37,    94,   124,    63,    58,    61,    59,
     123,   125
};
#endif

#define YYPACT_NINF (-252)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-350)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1007,  -108,  -252,    25,   -75,  -252,  -252,  -252,  -252,  -252,
     -46,  -252,  -252,  -252,   -26,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,     6,  -252,  -252,  -252,  3644,  3644,    60,  3644,  3580,
    -252,   -28,  -252,    12,  -252,  3644,   964,  -252,  -252,  -252,
     -25,   570,    49,   239,  -252,   104,     0,   133,  -252,  -252,
    -252,  -252,   114,  -252,  1438,  -252,   -85,  -252,   115,   311,
       7,     7,  -252,   239,  -252,  3245,  -252,  -252,  3277,  -252,
    -252,  -252,  -252,  3644,  -252,   -71,  -252,  -252,   -23,  -252,
    -252,  -252,  -252,    26,    38,   -67,  -252,   104,  -252,    85,
    -252,  1438,  -252,   114,  -252,  1140,    40,  3457,  1857,   311,
     311,   106,  -252,  3416,   120,  -252,  3345,  -252,   114,  3416,
    -252,  3375,    93,    60,   570,   144,  -252,    49,  -252,  2890,
       2,  -252,   -61,  -252,  -252,  -252,  -252,   149,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    2937,  2937,  3025,  -252,  -252,   201,   268,   272,  -252,  -252,
     246,  1532,  2937,  2937,  2890,  2890,  2890,  2890,  1140,  -252,
    -252,   159,   213,  -252,  -252,   436,  -252,   148,   141,   313,
      72,   258,   209,   223,   228,   319,   -14,  -252,  3017,  -252,
    -252,  -252,   231,   869,  -252,    63,  -252,    31,   265,   269,
    -252,   276,  -252,  -252,  -252,   282,  -252,  -252,   239,  -252,
    -252,   -77,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,     4,  -252,  1708,  -252,  -252,  1532,  -252,
    2667,  -252,  -252,  2667,  1678,   168,   305,   268,   272,  -252,
     123,   111,   330,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
     -54,   432,  -252,  -252,  1620,  1796,   438,  2667,  2667,  2667,
    2667,  2667,  2667,  2667,  2667,  2667,  2667,  2667,  2667,  2890,
    2890,  2890,  2890,  2890,  2890,  2890,  2890,  2890,  2890,  2890,
    2890,  2890,  2890,  2890,  2890,  2890,  2890,  2667,   570,   570,
     314,   570,  -252,  -252,   334,   338,  -252,  2667,   353,  2890,
     359,   385,   387,   398,   869,  -252,  -252,  -252,  -252,  -252,
     489,   383,   388,  1317,   410,   869,  -252,   411,   391,   414,
     415,  -252,   -39,  -252,  -252,   869,  -252,  -252,  -252,  -252,
     607,  -252,  -252,   416,   417,   419,   421,   422,   423,  -252,
     405,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  3098,
    2755,   420,    57,    57,  -252,   337,  -252,  3644,  -252,  -252,
     429,   114,  -252,  -252,   441,   443,   255,   216,  1992,  -252,
    -252,  2667,  3178,   341,   341,  -252,  2890,  1093,  -252,  -252,
     444,  -252,   170,  -252,   445,   349,  -252,   172,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,   148,   148,   141,   141,   313,   313,   313,   313,
      72,    72,   258,   209,   223,   228,   319,   -29,  -252,  -252,
    1140,  2667,  -252,  -252,    61,   869,   427,   869,  2667,  2667,
    2667,   459,  -252,   426,  -252,  -252,  -252,    68,  2667,   469,
    2667,  -252,   539,   539,  -252,  -252,  -252,  -252,  -252,  1229,
    1229,   541,   541,   542,   543,   869,   450,  -252,   454,   460,
    -252,   455,  1140,   337,   337,  3519,  2802,  -252,  -252,  -252,
    -252,  -252,   493,  2667,  2080,  -252,   193,  -252,  -252,  -252,
    -252,  -252,  -252,  2667,  -252,  -252,  -252,  2890,   195,   356,
    -252,   738,   869,  -252,   220,   221,   225,   462,  -252,  -252,
     226,   463,   237,  -252,    15,    34,  -252,  -252,  1405,  1405,
    -252,   440,  -252,   243,   252,  -252,   464,  -252,   530,  -252,
    -252,  -252,  -252,  -252,  -252,   470,  -252,   471,  2667,  1678,
     262,   378,   466,   267,  -252,  -252,  -252,  -252,  1140,  -252,
    -252,  -252,   869,   869,   869,  2667,   869,  2667,   869,  -252,
     452,  2667,  2667,  -252,   105,  2127,  2215,  1945,  -252,   541,
    -252,  -252,  2667,  -252,  -252,   473,   320,  2262,  1678,  2667,
    -252,   477,   499,  -252,  -252,   271,   501,   273,  -252,  -252,
     277,   283,  -252,   869,   285,   869,   289,  -252,  -252,  -252,
    -252,   497,  2667,   869,  -252,   869,   869,   290,  1375,  2350,
    -252,   294,   418,   482,  -252,   869,   465,   869,   467,   468,
     475,  -252,   869,  -252,   869,  2667,  -252,  -252,  -252,  -252,
    -252,  2667,   430,   481,   295,  -252,  2397,  1678,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,   869,   488,  2485,
    -252,   495,  -252,   299,   434,  -252,  1678,  -252,   300,  -252,
    -252,  2532,   457,  -252,  -252,   304,  2620,  -252,  -252,   306,
    -252
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   151,   147,   203,   149,   204,   205,   206,   201,
       0,   199,   200,   146,     0,   202,   162,   207,   208,   164,
     165,   158,   160,   166,   198,   156,   157,   159,   161,   163,
     167,     0,   177,   348,   347,   135,   133,     0,   131,   137,
     150,   172,   152,     0,   153,   140,     0,   341,   344,   343,
     148,     0,     0,     0,   188,     0,   193,   147,   203,   136,
     134,   218,     0,   230,   226,   124,     0,   142,   144,   213,
       0,     0,   132,     0,   139,     0,   169,   170,     0,   171,
     141,     1,   342,     0,   154,     0,   127,   128,     0,   214,
     215,   216,   217,     0,   196,     0,   194,     0,   148,     0,
     209,   227,   228,     0,   125,     0,     0,     0,     0,   211,
     212,     0,   176,   182,   150,   183,     0,   178,     0,     0,
     175,     0,     0,     0,     0,     0,   130,     0,   126,     0,
       0,   189,     0,   219,   210,   229,   143,   144,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,     4,    17,
       0,     0,     0,    97,    44,     0,     0,     0,    15,    16,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    36,
      39,    46,     0,    53,    52,    65,    67,    71,    74,    77,
      82,    85,    87,    89,    91,    93,    95,   104,     0,   108,
     255,   145,   279,     0,   350,     0,   224,   238,     0,   231,
     232,     0,   221,    65,   122,     0,   138,   181,     0,   173,
     179,     0,   185,   187,   184,   174,   345,   155,   346,   129,
     197,   191,   195,     0,   190,     0,    54,    55,     0,    62,
       0,    98,    99,     0,     0,     0,     0,   199,   200,   120,
       0,   239,     0,    56,    57,    58,    59,    60,    61,   258,
       0,     0,    42,    43,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,     0,   100,   281,     0,     4,   260,     0,   202,     0,
       0,     0,     0,     0,     0,   298,   299,   311,   301,   296,
       0,     0,     0,     0,     0,     0,   297,     0,     0,     0,
       0,   285,     0,   269,   123,     0,   283,   262,   263,   264,
       0,   265,   266,     0,     0,     0,     0,     0,     0,   267,
       0,   268,   272,   273,   274,   270,   271,   225,   234,     0,
       0,   235,   241,   244,   237,   242,   223,     0,   222,   220,
       0,     0,   180,   192,     0,     0,     0,     0,     0,    19,
      18,     0,     0,   241,   244,   240,     0,     0,   256,    41,
       0,    47,     0,    50,     0,     0,    40,     0,   110,   111,
     112,   113,   114,   115,   116,   117,   119,   118,   109,    68,
      69,    70,    72,    73,    75,    76,    80,    81,    78,    79,
      83,    84,    86,    88,    90,    92,    94,     0,   101,   102,
       0,     0,   103,   275,     0,     0,     0,     0,     0,     0,
       0,     0,   329,     0,   331,   332,   333,     0,     0,     0,
       0,   335,     0,     0,   286,   261,   280,   284,   282,     0,
       0,     0,     0,     0,     0,     0,     0,   251,     0,     0,
     247,     0,     0,   243,   245,     0,     0,   233,   168,   186,
      63,    64,     0,     0,     0,    21,     0,   121,    66,   257,
     259,    49,    48,     0,    38,    37,    45,     0,     0,     0,
     336,     0,     0,   278,     0,     0,     0,     0,   330,   334,
       0,     0,     0,     2,     0,     0,   295,   294,     0,     0,
     300,     0,   309,     0,     0,   302,     0,   312,     0,   276,
     252,   246,   248,   236,   253,     0,   249,     0,     0,     0,
       0,     0,     0,     0,    20,    51,    96,   106,     0,   107,
     337,   277,     0,     0,     0,     0,     0,     0,     0,     3,
       0,     0,     0,   292,     0,     0,     0,     0,   321,     0,
     323,   325,     0,   254,   250,     0,     0,     0,     0,     0,
      33,     0,   287,   291,   313,     0,   289,     0,   314,   338,
       0,     0,   293,     0,     0,     0,     0,   303,   304,   305,
     306,     0,     0,     0,   310,     0,     0,     0,     0,     0,
      23,     0,     0,     0,    32,     0,     0,     0,     0,     0,
       0,   317,     0,   319,     0,     0,   308,   322,   324,   326,
     327,     0,     0,     0,     0,    22,     0,     0,   288,   315,
     290,   316,   339,   340,   318,   320,   307,     0,     0,     0,
      35,     0,    25,     0,     0,   328,     0,    27,     0,    34,
      24,     0,     0,    26,    29,     0,     0,    28,    31,     0,
      30
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -252,   175,  -252,  -252,  -158,  -252,  -252,  -252,  -251,   -70,
    -150,   153,   157,    16,   211,   339,   336,   318,   335,   340,
    -252,  -103,  -252,  -252,  -252,  -105,  -118,  -125,    55,    33,
     447,   506,  -252,  -252,     1,  -252,   521,  -252,    10,  -252,
     -47,  -252,  -252,  -252,  -252,  -252,   558,    -3,   -90,  -252,
     281,   623,  -252,   573,   -80,   -10,  -252,   -19,   -63,   -62,
     -53,  -185,  -100,  -252,   345,   490,  -184,  -116,  -102,   296,
    -252,    -7,  -252,  -252,  -252,  -252,   587,   292,    64,  -252,
     210,   270,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
     162,   278,  -252,  -252,  -252,  -252,  -252,  -252,  -252,   412,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,   683,  -252,  -252
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   504,   169,   170,   171,   172,   173,   174,   382,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   290,   189,   239,   322,   205,   323,   324,
      35,    87,    88,    36,   123,    66,    67,    38,    39,    85,
      40,   115,    79,    41,    42,    43,   116,   117,   118,   211,
     212,    94,    44,    95,    96,    45,   101,    99,    93,    69,
      70,    71,   458,   199,   200,   242,   459,   355,   249,   250,
     325,   326,   327,   328,   193,   448,   329,   330,   331,   332,
     555,   508,   333,   334,   335,   336,   511,   337,   516,   592,
     512,   513,   338,   518,   339,   593,   595,   596,   637,   340,
     341,   342,   343,   344,   345,   346,    46,    47,    48,   106
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     190,    37,   235,   191,   220,   204,   387,   198,   109,   110,
     111,   102,   353,   354,   245,   246,   247,   248,    68,   286,
      54,    49,    54,   207,    54,    61,   204,   103,   114,   214,
      76,   114,    77,    34,   549,   361,    59,    60,   203,    72,
      74,   124,    50,   240,   104,   130,    80,    37,   135,    61,
     222,   223,   362,   549,   100,    51,   374,   375,   377,   203,
     125,    84,    52,   190,   131,   119,   114,    86,   119,   114,
     224,   241,   114,   371,   114,    61,   367,   378,    61,    34,
     226,   227,   229,   371,   137,   113,   126,    53,   113,   127,
     444,   134,   243,   244,   203,   203,   203,   203,   487,   213,
     276,   277,    75,   119,   137,    83,   119,   240,   197,   119,
     240,   119,   287,   210,   114,    62,   122,   476,   210,   399,
     400,   401,    54,   113,   550,   365,   113,   551,   366,   113,
      97,   113,    61,   221,   217,   363,    55,   385,   241,   349,
     128,   350,    78,   222,   352,   360,   552,    63,    64,   383,
      98,   119,   383,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   353,   349,   129,   350,    62,   417,
     192,   113,   347,   371,   426,   348,    63,    64,   351,   424,
     371,   114,   251,   252,   253,   278,   279,   374,   373,    65,
     490,   251,   252,   253,   133,   437,   204,   499,   292,   203,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   203,   203,   203,   203,   203,   203,   371,   119,   372,
     206,   350,    62,   533,   216,   461,   478,    63,    64,   203,
      63,    64,   370,   208,   582,   371,   463,   464,   113,   251,
     252,   253,    89,   105,    90,  -349,    91,   204,    92,   138,
     139,   140,   141,   142,   143,   144,   145,   463,   464,   272,
     273,   146,   147,   383,   148,   269,   477,   254,   149,   255,
     270,   271,   190,   218,   256,   480,   368,   105,   255,   482,
     203,   486,   483,   256,   483,   251,   252,   253,   280,   281,
     109,   110,   406,   407,   408,   409,   352,   431,   418,   419,
     580,   422,   534,   489,   537,   483,   203,   538,   439,   230,
     494,   495,   496,   231,   530,   190,   601,   232,   445,   373,
     500,   257,   502,   447,   474,   282,   255,   158,   159,   542,
     543,   256,   371,   371,   544,   546,   160,   371,   371,   274,
     275,   527,   213,   251,   252,   253,   548,   283,   624,   371,
     197,   285,   558,   284,   225,   559,   233,   190,   197,   234,
     523,   560,   293,   204,   559,   525,   472,   473,   531,   383,
     567,   566,   255,   197,   356,   643,   571,   256,   535,   483,
     606,   357,   608,   371,   536,   371,   609,   358,   648,   483,
     554,   554,   610,   359,   612,   371,   203,   371,   614,   620,
     655,   371,   371,   625,   641,   659,   483,   483,   650,   653,
     602,   483,   483,   657,   369,   660,   483,   203,   483,   107,
     493,   108,   420,   565,   421,   402,   403,   575,   599,   577,
     255,   404,   405,   190,   581,   256,   480,   584,   586,   376,
     622,   251,   252,   253,   597,   465,   383,   466,   519,   372,
     379,   350,   591,   251,   252,   253,   386,   251,   252,   253,
     485,   371,   383,   423,   603,  -329,   197,   539,   371,   644,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     251,   252,   253,   425,   447,   541,   427,   616,   652,   568,
     569,   410,   411,   428,   383,   429,   138,   139,   140,   141,
     142,   143,   144,   145,   506,   506,   430,   432,   146,   147,
     636,   148,   434,   507,   507,   149,   638,   435,   438,   440,
     441,   383,   442,   443,   449,   450,   626,   451,   255,   452,
     453,   454,   455,   256,   383,   572,   573,   574,   639,   576,
     255,   578,   651,   468,   255,   256,   383,   497,   462,   256,
     470,   383,   471,   481,   492,   498,   484,   501,   503,   510,
     515,   517,   348,   520,   268,   656,   522,   255,   557,   521,
     545,   547,   256,   561,   158,   159,   611,   562,   613,   563,
     570,   579,   564,   160,   598,   605,   617,   607,   618,   619,
       2,   604,   615,   627,   629,   640,   631,   632,   628,   646,
     630,   225,   414,   528,   633,   634,   529,   635,   294,   649,
     138,   139,   140,   141,   142,   143,   144,   145,   505,   413,
     415,   412,   146,   147,   136,   295,   416,     2,   296,   149,
     645,   150,   151,   219,    16,   291,   121,    19,    20,    21,
      22,    23,   469,    25,    26,    27,    28,    29,    30,    31,
      32,   152,   153,   297,    56,   154,   155,    57,    58,     5,
       6,     7,     8,     9,    10,   237,   238,    13,    14,   298,
     132,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,   158,   159,
     299,   300,   301,   194,   302,   303,   304,   160,   305,   306,
     307,   308,   467,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   161,   488,   491,   364,   556,
     509,   594,   433,   162,   163,   164,   165,   166,   167,    82,
     514,     0,     0,     0,     0,     0,   321,   192,   446,   294,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   295,     0,     2,   296,
     149,     0,   150,   151,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,   153,   297,     0,   154,   155,    57,    58,
       5,     6,     7,     8,     9,    10,   237,   238,    13,    14,
     298,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   158,
     159,   299,   300,   301,     0,   302,   303,   304,   160,   305,
     306,   307,   308,     0,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   161,     0,     0,     0,
       0,     0,     0,     0,   162,   163,   164,   165,   166,   167,
       0,     0,     0,     0,     0,     0,     0,   321,   192,   540,
     294,     0,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,   146,   147,     0,   295,     0,     2,
     296,   149,     0,   150,   151,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   152,   153,   297,     0,   154,   155,    57,
      58,     5,     6,     7,     8,     9,    10,   237,   238,    13,
      14,   298,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     158,   159,   299,   300,   301,     0,   302,   303,   304,   160,
     305,   306,   307,   308,    81,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   161,     0,     0,
       0,     0,     0,     0,     2,   162,   163,   164,   165,   166,
     167,     0,     0,     0,     0,     0,     0,     0,   321,   192,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     0,
       0,     0,     0,     0,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,     2,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,     0,     0,
       0,     0,     0,    33,     0,     0,   138,   139,   140,   141,
     142,   143,   144,   145,     0,     0,     0,     0,   146,   147,
       0,   148,     0,     0,     0,   149,     0,   150,   151,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,   152,   153,     0,
       0,   154,   155,   138,   139,   140,   141,   142,   143,   144,
     145,   156,   157,     0,     0,   146,   147,     0,   148,     0,
       0,     0,   149,     0,   150,   151,     0,     0,     0,     0,
       0,     0,     0,     0,   158,   159,     0,     0,     0,     0,
       0,     0,     0,   160,   152,   153,     0,     0,   154,   155,
       0,     0,     0,     0,     0,     0,     0,     0,   156,   157,
       0,   161,     0,     0,     0,     0,     0,     0,     0,   162,
     163,   164,   165,   166,   167,     0,     0,     0,     0,     0,
       0,   158,   159,   168,   479,     0,     0,     0,     0,     0,
     160,     0,   138,   139,   140,   141,   142,   143,   144,   145,
       0,     0,     0,     0,   146,   147,     0,   148,   161,     2,
       0,   149,     0,   150,   151,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,     0,     0,
     168,     0,     0,   152,   153,     0,     0,   154,   155,    57,
      58,     5,     6,     7,     8,     9,    10,   237,   238,    13,
      14,    15,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     158,   159,     0,     0,     0,     0,     0,     0,     0,   160,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,   161,     0,   149,
       0,   150,   151,     0,     0,   162,   163,   164,   165,   166,
     167,     0,     0,     0,     0,     0,     0,     0,   321,     0,
       0,   152,   153,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,   156,   157,     0,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,     0,     0,   149,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   161,     0,   149,     0,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,   436,     0,     0,   152,
     153,     0,     0,   154,   155,     0,   158,   159,     0,     0,
       0,     0,     0,   156,   157,   160,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   225,     0,   621,   158,   159,     0,    58,
       0,     6,     7,     8,     9,   160,    11,    12,     0,     0,
      15,     0,     0,    17,    18,     0,     0,     0,     0,     0,
      24,     0,     0,   161,     0,     0,     0,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,     0,     0,
       0,     0,     0,   236,   553,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,   146,   147,     0,
     148,     0,     2,     0,   149,    64,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   152,   153,     0,     0,
     154,   155,     0,    58,     0,     6,     7,     8,     9,     0,
     237,   238,     0,     0,    15,     0,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,   158,   159,     0,     0,     0,     0,     0,
       0,   380,   160,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     161,     0,   149,     0,   150,   151,     0,     0,   162,   163,
     164,   165,   166,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,     0,     0,   154,   155,
       0,     0,     0,     0,     0,     0,     0,     0,   156,   157,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   148,     0,     0,     0,
     149,   158,   159,     0,     0,     0,     0,     0,     0,   236,
     160,   138,   139,   140,   141,   142,   143,   144,   145,     0,
       0,     0,     0,   146,   147,     0,   148,     0,   161,   381,
     149,     0,   150,   151,     0,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   152,   153,     0,     0,   154,   155,     0,   158,
     159,     0,     0,     0,     0,     0,   156,   157,   160,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   225,     0,     0,   158,
     159,     0,     0,     0,     0,     0,     0,   384,   160,   138,
     139,   140,   141,   142,   143,   144,   145,     0,     0,     0,
       0,   146,   147,     0,   148,     0,   161,     0,   149,     0,
     150,   151,     0,     0,   162,   163,   164,   165,   166,   167,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     152,   153,     0,     0,   154,   155,     0,     0,     0,     0,
       0,     0,     0,     0,   156,   157,     0,     0,   201,     0,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,   158,   159,   149,
       0,   150,   151,     0,     0,     0,   160,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   152,     0,     0,   161,   154,   155,     0,     0,     0,
       0,     0,   162,   163,   164,   165,   166,   167,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,   587,   588,   589,   590,
     146,   147,     0,   148,     0,   161,     0,   149,   202,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,     0,     0,   154,   155,   138,   139,   140,   141,   142,
     143,   144,   145,   156,   157,     0,     0,   146,   147,     0,
     148,     0,     0,     0,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   159,     0,     0,
       0,     0,     0,     0,     0,   160,   152,   153,     0,     0,
     154,   155,     0,     0,     0,     0,     0,     0,     0,     0,
     156,   157,     0,   161,     0,     0,     0,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,     0,     0,
       0,     0,     0,   158,   159,     0,     0,     0,     0,     0,
       0,     0,   160,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     161,   475,   149,     0,   150,   151,     0,     0,   162,   163,
     164,   165,   166,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,     0,     0,   154,   155,
     138,   139,   140,   141,   142,   143,   144,   145,   156,   157,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,   158,   159,     0,     0,     0,     0,     0,     0,     0,
     160,   152,   153,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,   156,   157,     0,   161,   532,
       0,     0,     0,     0,     0,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   161,   583,   149,     0,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,     0,     0,   154,   155,   138,   139,   140,   141,   142,
     143,   144,   145,   156,   157,     0,     0,   146,   147,     0,
     148,     0,     0,     0,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   159,     0,     0,
       0,     0,     0,     0,     0,   160,   152,   153,     0,     0,
     154,   155,     0,     0,     0,     0,     0,     0,     0,     0,
     156,   157,     0,   161,   585,     0,     0,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,     0,     0,
       0,     0,     0,   158,   159,     0,     0,     0,     0,     0,
       0,     0,   160,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     161,   600,   149,     0,   150,   151,     0,     0,   162,   163,
     164,   165,   166,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,     0,     0,   154,   155,
     138,   139,   140,   141,   142,   143,   144,   145,   156,   157,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,   158,   159,     0,     0,     0,     0,     0,     0,     0,
     160,   152,   153,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,   156,   157,     0,   161,   623,
       0,     0,     0,     0,     0,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   161,   642,   149,     0,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
     153,     0,     0,   154,   155,   138,   139,   140,   141,   142,
     143,   144,   145,   156,   157,     0,     0,   146,   147,     0,
     148,     0,     0,     0,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   159,     0,     0,
       0,     0,     0,     0,     0,   160,   152,   153,     0,     0,
     154,   155,     0,     0,     0,     0,     0,     0,     0,     0,
     156,   157,     0,   161,   647,     0,     0,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,     0,     0,
       0,     0,     0,   158,   159,     0,     0,     0,     0,     0,
       0,     0,   160,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     161,   654,   149,     0,   150,   151,     0,     0,   162,   163,
     164,   165,   166,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,   153,     0,     0,   154,   155,
     138,   139,   140,   141,   142,   143,   144,   145,   156,   157,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,   158,   159,     0,     0,     0,     0,     0,     0,     0,
     160,   152,   153,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,   156,   157,     0,   161,   658,
       0,     0,     0,     0,     0,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     0,     0,     0,
     146,   147,     0,   148,     0,   161,     0,   149,     0,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
       0,     0,     0,   154,   155,   138,   139,   140,   141,   142,
     143,   144,   145,     0,     0,     0,     0,   146,   147,     0,
     148,     0,     0,     0,   149,     0,   150,   151,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   159,     0,     0,
       0,     0,     0,     0,     0,   160,   152,     0,     0,     0,
     154,   155,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   161,     0,     0,   460,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,     0,     0,
       0,     0,     0,   158,   159,     0,     0,     0,     0,     0,
       0,     0,   160,   138,   139,   140,   141,   142,   143,   144,
     145,     0,     0,     0,     0,   146,   147,     0,   148,     0,
     161,     0,   149,   526,   150,   151,     0,     0,   162,   163,
     164,   165,   166,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   152,     0,     0,     0,   154,   155,
     138,   139,   140,   141,   142,   143,   144,   145,     0,     0,
       0,     0,   146,   147,     0,   148,     0,     0,     0,   149,
       0,   150,   151,     0,     0,     0,     0,     0,     0,     0,
       0,   158,   159,     0,     0,     0,     0,     0,     0,     0,
     160,   152,     0,     0,     0,   154,   155,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   161,     0,
       0,     0,     0,     0,     0,     0,   162,   163,   164,   165,
     166,   167,     0,     0,     0,     0,     0,     0,   158,   159,
       0,     0,     0,     0,     0,     0,     0,   160,   138,   139,
     140,   141,   142,   143,   144,   145,     0,     2,     0,     0,
     146,   147,     0,   148,     0,   225,     0,   149,     0,   150,
     151,     0,     0,   162,   163,   164,   165,   166,   167,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   152,
       0,     0,     0,   154,   155,   288,   289,     0,    14,     0,
       0,    16,     0,     0,    19,    20,    21,    22,    23,     0,
      25,    26,    27,    28,    29,    30,    31,    32,     0,   456,
       0,     0,     0,     0,     0,     0,   158,   159,     0,     0,
       0,     0,     0,     0,     0,   160,    61,     0,     2,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,     0,     0,     0,     0,
       0,   162,   163,   164,   165,   166,   167,     0,    57,    58,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,   456,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     2,     0,
       0,     0,     0,     0,     0,     0,   349,   457,   350,     0,
       0,     0,     0,     0,    63,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    57,    58,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,     0,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   372,   457,   350,     0,
       0,     0,     0,     0,    63,    64,    58,     2,     6,     7,
       8,     9,     0,    11,    12,     0,     0,    15,     0,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,     0,     0,    58,     0,
       6,     7,     8,     9,     0,    11,    12,     0,     0,    15,
       0,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   112,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,    58,     0,     6,     7,
       8,     9,     0,    11,    12,     0,     0,    15,   120,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    58,     0,     6,     7,
       8,     9,     0,    11,    12,     0,     2,    15,     0,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,     0,     0,   195,     0,
       0,     0,     0,     0,     0,     0,     0,    58,     0,     6,
       7,     8,     9,     0,    11,    12,   209,     2,    15,     0,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   215,    57,    58,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
     456,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,     0,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   196,     0,     0,    57,
      58,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,     0,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   524,     0,
      57,    58,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,     0,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,     0,     0,     2,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    73,    57,    58,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,     0,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32
};

static const yytype_int16 yycheck[] =
{
     105,     0,   160,   105,   129,   108,   257,   107,    70,    71,
      73,    64,   197,   197,   164,   165,   166,   167,    37,    33,
      18,   129,    18,   113,    18,    18,   129,   112,    75,   119,
      18,    78,    20,     0,    19,   112,    35,    36,   108,    38,
      39,   112,    17,   161,   129,   112,    45,    46,   101,    18,
     130,   112,   129,    19,    64,   130,   241,   241,   112,   129,
     131,    51,   108,   168,   131,    75,   113,    18,    78,   116,
     131,   161,   119,   112,   121,    18,   234,   131,    18,    46,
     150,   151,   152,   112,   103,    75,   109,   113,    78,   112,
     129,   101,   162,   163,   164,   165,   166,   167,   127,   118,
      28,    29,   130,   113,   123,   130,   116,   225,   107,   119,
     228,   121,   126,   116,   161,   108,    83,   368,   121,   269,
     270,   271,    18,   113,   109,   230,   116,   112,   233,   119,
     130,   121,    18,   131,   124,   131,   130,   255,   228,   108,
     114,   110,   130,   223,   197,   208,   112,   116,   117,   254,
      17,   161,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   349,   108,   128,   110,   108,   287,
     130,   161,   109,   112,   299,   112,   116,   117,   197,   297,
     112,   228,    23,    24,    25,   113,   114,   372,   241,   129,
     129,    23,    24,    25,   109,   313,   299,   129,   188,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   112,   228,   108,
     114,   110,   108,   474,   131,   350,   376,   116,   117,   299,
     116,   117,   109,   113,   129,   112,   352,   353,   228,    23,
      24,    25,     3,   128,     5,   130,     7,   350,     9,     3,
       4,     5,     6,     7,     8,     9,    10,   373,   374,   118,
     119,    15,    16,   368,    18,   117,   371,   108,    22,   110,
     122,   123,   377,   129,   115,   377,   108,   128,   110,   109,
     350,   109,   112,   115,   112,    23,    24,    25,    30,    31,
     352,   353,   276,   277,   278,   279,   349,   304,   288,   289,
     551,   291,   109,   421,   109,   112,   376,   112,   315,   108,
     428,   429,   430,    45,   472,   420,   567,    45,   325,   372,
     438,   108,   440,   330,   108,   116,   110,    81,    82,   109,
     109,   115,   112,   112,   109,   109,    90,   112,   112,    26,
      27,   466,   361,    23,    24,    25,   109,   124,   599,   112,
     349,    32,   109,   125,   108,   112,   110,   462,   357,   113,
     462,   109,   131,   466,   112,   465,   111,   112,   473,   474,
     108,   529,   110,   372,   109,   626,   109,   115,   483,   112,
     109,   112,   109,   112,   487,   112,   109,   111,   639,   112,
     508,   509,   109,   111,   109,   112,   466,   112,   109,   109,
     651,   112,   112,   109,   109,   656,   112,   112,   109,   109,
     568,   112,   112,   109,   109,   109,   112,   487,   112,   108,
     427,   110,   108,   528,   110,   272,   273,   545,   108,   547,
     110,   274,   275,   538,   552,   115,   538,   555,   556,   109,
     598,    23,    24,    25,   562,   108,   551,   110,   455,   108,
      18,   110,   557,    23,    24,    25,    18,    23,    24,    25,
     111,   112,   567,   129,   569,   127,   465,   111,   112,   627,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      23,    24,    25,   130,   491,   492,   127,   592,   646,   111,
     112,   280,   281,   108,   599,   108,     3,     4,     5,     6,
       7,     8,     9,    10,   449,   450,   108,    18,    15,    16,
     615,    18,   129,   449,   450,    22,   621,   129,   108,   108,
     129,   626,   108,   108,   108,   108,   108,   108,   110,   108,
     108,   108,   127,   115,   639,   542,   543,   544,   108,   546,
     110,   548,   108,   114,   110,   115,   651,    88,   128,   115,
     109,   656,   109,   109,   127,   129,   111,    88,    19,    18,
      18,    18,   112,   109,   128,   108,   111,   110,   128,   109,
     108,   108,   115,   109,    81,    82,   583,    47,   585,   109,
     114,   129,   111,    90,   111,    86,   593,    86,   595,   596,
      20,   114,    95,   111,   129,   114,   129,   129,   605,   111,
     607,   108,   284,   110,   129,   612,   113,   614,     1,   114,
       3,     4,     5,     6,     7,     8,     9,    10,   443,   283,
     285,   282,    15,    16,   103,    18,   286,    20,    21,    22,
     637,    24,    25,   127,    64,   188,    78,    67,    68,    69,
      70,    71,   361,    73,    74,    75,    76,    77,    78,    79,
      80,    44,    45,    46,    31,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      97,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,   106,    87,    88,    89,    90,    91,    92,
      93,    94,   357,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   420,   425,   228,   509,
     450,   559,   310,   116,   117,   118,   119,   120,   121,    46,
     452,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,    20,    21,
      22,    -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    -1,    87,    88,    89,    90,    91,
      92,    93,    94,    -1,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   116,   117,   118,   119,   120,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,   131,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,    20,
      21,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    -1,    87,    88,    89,    90,
      91,    92,    93,    94,     0,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,    -1,
      -1,    -1,    -1,    -1,    20,   116,   117,   118,   119,   120,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    20,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,   129,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    44,    45,    -1,
      -1,    48,    49,     3,     4,     5,     6,     7,     8,     9,
      10,    58,    59,    -1,    -1,    15,    16,    -1,    18,    -1,
      -1,    -1,    22,    -1,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    81,    82,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    90,    44,    45,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    59,
      -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   116,
     117,   118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,   130,   131,    -1,    -1,    -1,    -1,    -1,
      90,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,   108,    20,
      -1,    22,    -1,    24,    25,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     130,    -1,    -1,    44,    45,    -1,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,   108,    -1,    22,
      -1,    24,    25,    -1,    -1,   116,   117,   118,   119,   120,
     121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,
      -1,    44,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    59,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,    -1,    -1,    22,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   108,    -1,    22,    -1,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,    44,
      45,    -1,    -1,    48,    49,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    58,    59,    90,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,   110,    81,    82,    -1,    51,
      -1,    53,    54,    55,    56,    90,    58,    59,    -1,    -1,
      62,    -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,     1,   129,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    -1,    20,    -1,    22,   117,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    44,    45,    -1,    -1,
      48,    49,    -1,    51,    -1,    53,    54,    55,    56,    -1,
      58,    59,    -1,    -1,    62,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    90,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     108,    -1,    22,    -1,    24,    25,    -1,    -1,   116,   117,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    59,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,
      22,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      90,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,   108,   109,
      22,    -1,    24,    25,    -1,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    44,    45,    -1,    -1,    48,    49,    -1,    81,
      82,    -1,    -1,    -1,    -1,    -1,    58,    59,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,    -1,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,     1,    90,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,    -1,   108,    -1,    22,    -1,
      24,    25,    -1,    -1,   116,   117,   118,   119,   120,   121,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      44,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    59,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,    81,    82,    22,
      -1,    24,    25,    -1,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    44,    -1,    -1,   108,    48,    49,    -1,    -1,    -1,
      -1,    -1,   116,   117,   118,   119,   120,   121,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    -1,    18,    -1,   108,    -1,    22,   111,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,    -1,    -1,    48,    49,     3,     4,     5,     6,     7,
       8,     9,    10,    58,    59,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    44,    45,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    59,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     108,   109,    22,    -1,    24,    25,    -1,    -1,   116,   117,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    49,
       3,     4,     5,     6,     7,     8,     9,    10,    58,    59,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    44,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    59,    -1,   108,   109,
      -1,    -1,    -1,    -1,    -1,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   108,   109,    22,    -1,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,    -1,    -1,    48,    49,     3,     4,     5,     6,     7,
       8,     9,    10,    58,    59,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    44,    45,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    59,    -1,   108,   109,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     108,   109,    22,    -1,    24,    25,    -1,    -1,   116,   117,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    49,
       3,     4,     5,     6,     7,     8,     9,    10,    58,    59,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    44,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    59,    -1,   108,   109,
      -1,    -1,    -1,    -1,    -1,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   108,   109,    22,    -1,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      45,    -1,    -1,    48,    49,     3,     4,     5,     6,     7,
       8,     9,    10,    58,    59,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    44,    45,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    59,    -1,   108,   109,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     108,   109,    22,    -1,    24,    25,    -1,    -1,   116,   117,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    45,    -1,    -1,    48,    49,
       3,     4,     5,     6,     7,     8,     9,    10,    58,    59,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    44,    45,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    58,    59,    -1,   108,   109,
      -1,    -1,    -1,    -1,    -1,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    -1,    18,    -1,   108,    -1,    22,    -1,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,    48,    49,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    44,    -1,    -1,    -1,
      48,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    -1,   111,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    -1,    -1,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    90,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    -1,
     108,    -1,    22,   111,    24,    25,    -1,    -1,   116,   117,
     118,   119,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    44,    -1,    -1,    -1,    48,    49,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    -1,    18,    -1,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      90,    44,    -1,    -1,    -1,    48,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   116,   117,   118,   119,
     120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    81,    82,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    90,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    20,    -1,    -1,
      15,    16,    -1,    18,    -1,   108,    -1,    22,    -1,    24,
      25,    -1,    -1,   116,   117,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,    48,    49,    58,    59,    -1,    61,    -1,
      -1,    64,    -1,    -1,    67,    68,    69,    70,    71,    -1,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    82,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    90,    18,    -1,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   116,   117,   118,   119,   120,   121,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,   109,   110,    -1,
      -1,    -1,    -1,    -1,   116,   117,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   108,   109,   110,    -1,
      -1,    -1,    -1,    -1,   116,   117,    51,    20,    53,    54,
      55,    56,    -1,    58,    59,    -1,    -1,    62,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    -1,    51,    -1,
      53,    54,    55,    56,    -1,    58,    59,    -1,    -1,    62,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    -1,    -1,    62,   131,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    51,    -1,    53,    54,
      55,    56,    -1,    58,    59,    -1,    20,    62,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    -1,    -1,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,    -1,    53,
      54,    55,    56,    -1,    58,    59,   131,    20,    62,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
       1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    20,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,   129,   161,   162,   165,   166,   169,   170,
     172,   175,   176,   177,   184,   187,   238,   239,   240,   129,
      17,   130,   108,   113,    18,   130,   183,    50,    51,   166,
     166,    18,   108,   116,   117,   129,   167,   168,   189,   191,
     192,   193,   166,   113,   166,   130,    18,    20,   130,   174,
     166,     0,   239,   130,   170,   171,    18,   163,   164,     3,
       5,     7,     9,   190,   183,   185,   186,   130,    17,   189,
     187,   188,   192,   112,   129,   128,   241,   108,   110,   191,
     191,   190,   131,   170,   172,   173,   178,   179,   180,   187,
     131,   178,   161,   166,   112,   131,   109,   112,   114,   128,
     112,   131,   185,   109,   187,   192,   168,   189,     3,     4,
       5,     6,     7,     8,     9,    10,    15,    16,    18,    22,
      24,    25,    44,    45,    48,    49,    58,    59,    81,    82,
      90,   108,   116,   117,   118,   119,   120,   121,   130,   134,
     135,   136,   137,   138,   139,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   156,
     157,   200,   130,   206,   208,     1,   109,   166,   194,   195,
     196,     1,   111,   141,   153,   159,   114,   180,   113,   131,
     179,   181,   182,   189,   180,   131,   131,   170,   129,   163,
     159,   131,   186,   112,   131,   108,   141,   141,   108,   141,
     108,    45,    45,   110,   113,   136,     1,    58,    59,   157,
     158,   180,   197,   141,   141,   142,   142,   142,   142,   200,
     201,    23,    24,    25,   108,   110,   115,   108,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,   128,   117,
     122,   123,   118,   119,    26,    27,    28,    29,   113,   114,
      30,    31,   116,   124,   125,    32,    33,   126,    58,    59,
     155,   162,   170,   131,     1,    18,    21,    46,    62,    83,
      84,    85,    87,    88,    89,    91,    92,    93,    94,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   129,   158,   160,   161,   202,   203,   204,   205,   208,
     209,   210,   211,   214,   215,   216,   217,   219,   224,   226,
     231,   232,   233,   234,   235,   236,   237,   109,   112,   108,
     110,   189,   192,   193,   198,   199,   109,   112,   111,   111,
     190,   112,   129,   131,   197,   157,   157,   136,   108,   109,
     109,   112,   108,   192,   193,   198,   109,   112,   131,    18,
       1,   109,   140,   157,     1,   158,    18,   140,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   142,
     142,   142,   143,   143,   144,   144,   145,   145,   145,   145,
     146,   146,   147,   148,   149,   150,   151,   158,   170,   170,
     108,   110,   170,   129,   158,   130,   159,   127,   108,   108,
     108,   203,    18,   231,   129,   129,   129,   158,   108,   203,
     108,   129,   108,   108,   129,   203,   131,   203,   207,   108,
     108,   108,   108,   108,   108,   127,     1,   109,   194,   198,
     111,   159,   128,   199,   199,   108,   110,   196,   114,   182,
     109,   109,   111,   112,   108,   109,   140,   157,   142,   131,
     200,   109,   109,   112,   111,   111,   109,   127,   201,   158,
     129,   209,   127,   203,   158,   158,   158,    88,   129,   129,
     158,    88,   158,    19,   133,   133,   160,   210,   213,   213,
      18,   218,   222,   223,   223,    18,   220,    18,   225,   203,
     109,   109,   111,   200,   109,   194,   111,   159,   110,   113,
     136,   157,   109,   140,   109,   157,   153,   109,   112,   111,
     131,   203,   109,   109,   109,   108,   109,   108,   109,    19,
     109,   112,   112,   129,   158,   212,   212,   128,   109,   112,
     109,   109,    47,   109,   111,   157,   136,   108,   111,   112,
     114,   109,   203,   203,   203,   158,   203,   158,   203,   129,
     140,   158,   129,   109,   158,   109,   158,    11,    12,    13,
      14,   157,   221,   227,   222,   228,   229,   158,   111,   108,
     109,   140,   136,   157,   114,    86,   109,    86,   109,   109,
     109,   203,   109,   203,   109,    95,   157,   203,   203,   203,
     109,   110,   136,   109,   140,   109,   108,   111,   203,   129,
     203,   129,   129,   129,   203,   203,   157,   230,   157,   108,
     114,   109,   109,   140,   136,   203,   111,   109,   140,   114,
     109,   108,   136,   109,   109,   140,   108,   109,   109,   140,
     109
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   132,   133,   133,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   136,   136,   136,   136,
     136,   136,   136,   136,   137,   138,   139,   139,   139,   139,
     140,   140,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   142,   142,   143,   143,   143,
     143,   144,   144,   144,   145,   145,   145,   146,   146,   146,
     146,   146,   147,   147,   147,   148,   148,   149,   149,   150,
     150,   151,   151,   152,   152,   153,   153,   154,   154,   154,
     155,   155,   155,   155,   156,   156,   156,   156,   157,   157,
     157,   157,   157,   157,   157,   157,   157,   157,   157,   157,
     158,   158,   159,   160,   161,   161,   162,   163,   164,   164,
     165,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   167,   167,   168,   168,   169,   169,   169,   169,
     170,   170,   170,   170,   171,   171,   172,   172,   172,   172,
     172,   172,   172,   172,   172,   172,   172,   172,   173,   174,
     174,   175,   176,   176,   176,   176,   176,   177,   178,   178,
     179,   180,   180,   180,   180,   181,   181,   182,   183,   184,
     184,   184,   184,   184,   185,   185,   186,   186,   187,   187,
     187,   187,   187,   187,   187,   187,   187,   187,   187,   188,
     188,   189,   189,   189,   190,   190,   190,   190,   191,   191,
     191,   191,   191,   191,   191,   191,   192,   192,   192,   192,
     193,   194,   195,   195,   195,   196,   196,   196,   196,   197,
     197,   198,   198,   198,   198,   198,   199,   199,   199,   199,
     199,   199,   199,   199,   199,   200,   200,   200,   201,   201,
     202,   203,   203,   204,   204,   204,   204,   204,   204,   204,
     204,   204,   204,   204,   204,   204,   205,   205,   205,   206,
     207,   208,   208,   209,   209,   210,   210,   211,   211,   211,
     211,   211,   212,   212,   213,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   221,   221,   221,   222,   222,   223,
     223,   224,   225,   226,   226,   226,   226,   226,   226,   226,
     226,   227,   226,   228,   226,   229,   226,   230,   226,   231,
     232,   232,   232,   232,   232,   233,   234,   235,   236,   236,
     237,   238,   238,   238,   239,   239,   239,   239,   239,   241,
     240
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       5,     4,     8,     7,    10,     9,    11,    10,    12,    11,
      14,    13,     7,     6,    10,     9,     1,     4,     4,     1,
       3,     3,     2,     2,     1,     4,     1,     3,     4,     4,
       1,     3,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     4,     4,     1,     4,     1,     3,     3,
       3,     1,     3,     3,     1,     3,     3,     1,     3,     3,
       3,     3,     1,     3,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     5,     1,     2,     2,
       1,     2,     2,     2,     1,     2,     5,     5,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     1,     1,     2,     3,     4,     1,     1,     3,
       4,     1,     2,     1,     2,     1,     2,     1,     4,     2,
       1,     2,     1,     3,     1,     3,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     2,     1,     4,     4,     3,     3,     1,     1,     2,
       3,     2,     1,     1,     2,     1,     3,     1,     1,     4,
       5,     5,     6,     2,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       4,     3,     4,     4,     3,     4,     1,     2,     2,     3,
       1,     1,     1,     3,     2,     2,     4,     2,     1,     1,
       2,     1,     1,     2,     1,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     4,     1,     3,     4,     1,     3,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     4,     3,     1,
       1,     2,     3,     1,     2,     1,     2,     5,     7,     5,
       7,     5,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     5,     4,     1,
       3,     1,     1,     5,     5,     7,     7,     6,     7,     6,
       7,     0,     6,     0,     6,     0,     6,     0,     8,     1,
       3,     2,     2,     2,     3,     2,     3,     4,     5,     7,
       7,     1,     2,     2,     1,     5,     5,     1,     1,     0,
       4
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 281 "src/parse.yy"
                           { (yyval.stringVal) = new std::string(*yylval.stringVal); }
#line 2893 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 283 "src/parse.yy"
    {
        std::string s = *((std::string *)(yyvsp[-1].stringVal));
        s += *yylval.stringVal;
        (yyval.stringVal) = new std::string(s);
    }
#line 2903 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 291 "src/parse.yy"
                       {
        const char *name = yylval.stringVal->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = NULL;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == NULL) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
    }
#line 2927 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 310 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 2936 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 314 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 2945 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 318 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 2954 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 322 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 2963 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 326 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 2972 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 330 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 2981 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 334 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 2990 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 338 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 2999 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 342 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           yylval.floatVal, (yylsp[0]));
    }
#line 3008 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 346 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           yylval.doubleVal, (yylsp[0]));
    }
#line 3017 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_TRUE  */
#line 350 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 3025 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_FALSE  */
#line 353 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 3033 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_NULL  */
#line 356 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 3041 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 18: /* primary_expression: '(' expression ')'  */
#line 361 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 3047 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' error ')'  */
#line 362 "src/parse.yy"
                    { (yyval.expr) = NULL; }
#line 3053 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 20: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 367 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 3063 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 373 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 3073 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 380 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3083 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 386 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3093 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 393 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3103 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 399 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3113 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 405 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3123 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 411 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3133 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 418 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3142 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 423 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3151 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 428 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 3160 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 433 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3169 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 440 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3179 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 446 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3189 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 452 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3199 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 458 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3209 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 37: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 468 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3215 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 38: /* postfix_expression: postfix_expression '[' error ']'  */
#line 470 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3221 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 40: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 473 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false); }
#line 3227 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 475 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true); }
#line 3233 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 477 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3239 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 43: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 479 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3245 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 44: /* intrinsic_name: TOKEN_INTRINSIC_CALL  */
#line 484 "src/parse.yy"
      {
          (yyval.stringVal) = yylval.stringVal;
      }
#line 3253 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 45: /* intrincall_expression: intrinsic_name '(' argument_expression_list ')'  */
#line 491 "src/parse.yy"
      {
          std::string *name = (yyvsp[-3].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = NULL;
          if (sym != NULL)
              fSym = new FunctionSymbolExpr(fname, funcs, (yylsp[-3]));
          (yyval.expr) = new FunctionCallExpr(fSym, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));

      }
#line 3270 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 47: /* funcall_expression: postfix_expression '(' ')'  */
#line 508 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3276 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 48: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 510 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3282 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 49: /* funcall_expression: postfix_expression '(' error ')'  */
#line 512 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3288 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 50: /* argument_expression_list: assignment_expression  */
#line 516 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3294 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 51: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 518 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3309 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 54: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 534 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3315 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 55: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 536 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3321 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 56: /* unary_expression: '&' unary_expression  */
#line 538 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3327 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 57: /* unary_expression: '*' unary_expression  */
#line 540 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3333 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 58: /* unary_expression: '+' cast_expression  */
#line 542 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3339 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 59: /* unary_expression: '-' cast_expression  */
#line 544 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3345 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 60: /* unary_expression: '~' cast_expression  */
#line 546 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3351 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 61: /* unary_expression: '!' cast_expression  */
#line 548 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3357 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 62: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 550 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3363 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 63: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 552 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3369 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 64: /* unary_expression: TOKEN_ALLOCA '(' assignment_expression ')'  */
#line 554 "src/parse.yy"
      {
          (yyval.expr) = new AllocaExpr((yyvsp[-1].expr), Union((yylsp[-3]), (yylsp[0])));
      }
#line 3377 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 66: /* cast_expression: '(' type_name ')' cast_expression  */
#line 562 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3385 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 68: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 570 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3391 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 69: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 572 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3397 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 70: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 574 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3403 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 72: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 580 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3409 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 73: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 582 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3415 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 75: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 588 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3421 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 76: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 590 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3427 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 78: /* relational_expression: relational_expression '<' shift_expression  */
#line 596 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3433 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 79: /* relational_expression: relational_expression '>' shift_expression  */
#line 598 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3439 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 80: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 600 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3445 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 81: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 602 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3451 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 83: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 608 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3457 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 84: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 610 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3463 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 86: /* and_expression: and_expression '&' equality_expression  */
#line 616 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3469 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 88: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 622 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3475 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 90: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 628 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3481 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 92: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 634 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3487 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 94: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 640 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3493 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 96: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 646 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3499 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 97: /* rate_qualified_new: TOKEN_NEW  */
#line 650 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3505 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 98: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 651 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3511 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 99: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 652 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3517 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 100: /* rate_qualified_type_specifier: type_specifier  */
#line 656 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 3523 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 101: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 658 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 3538 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 102: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 669 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 3553 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 103: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 680 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == NULL) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = NULL;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = NULL;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 3578 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 105: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 705 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), NULL, NULL, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 3586 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 106: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 709 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), NULL, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 3594 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 107: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 713 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), NULL, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 3602 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 109: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 721 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3608 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 110: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 723 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3614 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 111: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 725 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3620 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 112: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 727 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3626 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 113: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 729 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3632 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 114: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 731 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3638 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 115: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 733 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3644 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 116: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 735 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3650 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 117: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 737 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3656 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 118: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 739 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3662 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 119: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 741 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3668 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 121: /* expression: expression ',' assignment_expression  */
#line 747 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3674 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 123: /* declaration_statement: declaration  */
#line 756 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == NULL) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = NULL;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == NULL)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = NULL;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 3701 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 124: /* declaration: declaration_specifiers ';'  */
#line 782 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 3709 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 125: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 786 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
      }
#line 3717 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 126: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 793 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 3723 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 127: /* declspec_item: TOKEN_IDENTIFIER  */
#line 798 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yylval.stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
    }
#line 3734 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 128: /* declspec_list: declspec_item  */
#line 808 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
    }
#line 3743 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 129: /* declspec_list: declspec_list ',' declspec_item  */
#line 813 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != NULL)
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 3753 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 130: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 822 "src/parse.yy"
    {
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 3761 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 131: /* declaration_specifiers: storage_class_specifier  */
#line 829 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, (yyvsp[0].storageClass));
      }
#line 3769 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 132: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 833 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 3787 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 133: /* declaration_specifiers: declspec_specifier  */
#line 847 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != NULL)
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
      }
#line 3797 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 134: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 853 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != NULL && declSpecList != NULL) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);
          }
          (yyval.declSpecs) = ds;
      }
#line 3811 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 135: /* declaration_specifiers: soa_width_specifier  */
#line 863 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 3821 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 136: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 869 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 3836 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 137: /* declaration_specifiers: type_specifier  */
#line 880 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 3844 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 138: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 884 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 3854 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 139: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 890 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->baseType != NULL) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  }
                  else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 3876 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 140: /* declaration_specifiers: type_qualifier  */
#line 908 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 3884 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 141: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 912 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 3895 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 142: /* init_declarator_list: init_declarator  */
#line 922 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3906 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 143: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 929 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3921 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 145: /* init_declarator: declarator '=' initializer  */
#line 944 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 3931 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 146: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 952 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 3937 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 147: /* storage_class_specifier: TOKEN_EXTERN  */
#line 953 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 3943 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 148: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 954 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 3949 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 149: /* storage_class_specifier: TOKEN_STATIC  */
#line 955 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 3955 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 150: /* type_specifier: atomic_var_type_specifier  */
#line 959 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 3961 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 151: /* type_specifier: TOKEN_TYPE_NAME  */
#line 961 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
    }
#line 3970 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 152: /* type_specifier: struct_or_union_specifier  */
#line 965 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 3976 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 153: /* type_specifier: enum_specifier  */
#line 966 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 3982 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 154: /* type_specifier_list: type_specifier  */
#line 971 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.typeList) = NULL;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 3997 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 155: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 982 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == NULL)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 4009 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 156: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 992 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 4015 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 157: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 993 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 4021 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 158: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 994 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 4027 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 159: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 995 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 4033 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 160: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 996 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 4039 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 161: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 997 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 4045 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 162: /* atomic_var_type_specifier: TOKEN_INT  */
#line 998 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 4051 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 163: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 999 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 4057 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 164: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 1000 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 4063 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 165: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 1001 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 4069 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 166: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 1002 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 4075 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 167: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 1003 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 4081 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 168: /* short_vec_specifier: atomic_var_type_specifier '<' int_constant '>'  */
#line 1008 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : NULL;
    }
#line 4089 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 169: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 1014 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4095 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 170: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 1015 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4101 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 171: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 1020 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == NULL) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == NULL &&
                  CastType<UndefinedStructType>(st) == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = NULL;
              }
              else
                  (yyval.type) = st;
         }
      }
#line 4124 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 173: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1043 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false,
                                              Variability::Unbound, false, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
          }
          else
              (yyval.type) = NULL;
      }
#line 4148 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 174: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1063 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, true, (yylsp[-3]));
          }
          else
              (yyval.type) = NULL;
      }
#line 4166 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 175: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1077 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, true, (yylsp[-2]));
      }
#line 4178 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 176: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1085 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, false, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 4196 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 178: /* struct_declaration_list: struct_declaration  */
#line 1106 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4207 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 179: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1113 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4222 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 180: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1127 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != NULL && (yyvsp[-1].structDeclaratorList) != NULL) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : NULL; }
#line 4228 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 184: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1135 "src/parse.yy"
    {
        if ((yyvsp[0].type) != NULL) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = NULL;
        }
    }
#line 4309 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 185: /* struct_declarator_list: struct_declarator  */
#line 1216 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4320 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 186: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1223 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4335 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 187: /* struct_declarator: declarator  */
#line 1236 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4341 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 188: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1244 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4347 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 189: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1248 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4355 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 190: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1252 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4363 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 191: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1256 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4371 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 192: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1260 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4379 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 193: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1264 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == NULL) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = NULL;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = NULL;
              }
              else
                  (yyval.enumType) = enumType;
          }
      }
#line 4403 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 194: /* enumerator_list: enumerator  */
#line 1287 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == NULL)
              (yyval.symbolList) = NULL;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 4417 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 195: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1297 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != NULL)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 4432 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 196: /* enumerator: enum_identifier  */
#line 1311 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]));
      }
#line 4440 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 197: /* enumerator: enum_identifier '=' constant_expression  */
#line 1315 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].constCharPtr) != NULL && (yyvsp[0].expr) != NULL &&
              lGetConstantInt((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]));
              sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                              (uint32_t)value, (yylsp[0]));
              (yyval.symbol) = sym;
          }
          else
              (yyval.symbol) = NULL;
      }
#line 4457 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 198: /* type_qualifier: TOKEN_CONST  */
#line 1330 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 4463 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 199: /* type_qualifier: TOKEN_UNIFORM  */
#line 1331 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 4469 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 200: /* type_qualifier: TOKEN_VARYING  */
#line 1332 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 4475 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 201: /* type_qualifier: TOKEN_TASK  */
#line 1333 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 4481 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 202: /* type_qualifier: TOKEN_UNMASKED  */
#line 1334 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 4487 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 203: /* type_qualifier: TOKEN_EXPORT  */
#line 1335 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 4493 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 204: /* type_qualifier: TOKEN_INLINE  */
#line 1336 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 4499 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 205: /* type_qualifier: TOKEN_NOINLINE  */
#line 1337 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 4505 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 206: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1338 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 4511 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 207: /* type_qualifier: TOKEN_SIGNED  */
#line 1339 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 4517 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 208: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1340 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 4523 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 209: /* type_qualifier_list: type_qualifier  */
#line 1345 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 4531 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 210: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1349 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 4539 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 211: /* declarator: pointer direct_declarator  */
#line 1356 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4555 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 212: /* declarator: reference direct_declarator  */
#line 1368 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4571 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 214: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1383 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 4577 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 215: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1384 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4583 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 216: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1385 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4589 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 217: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1386 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4595 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 218: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1391 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4605 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 219: /* direct_declarator: '(' declarator ')'  */
#line 1397 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 4613 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 220: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1401 "src/parse.yy"
    {
        int size;
        if ((yyvsp[-3].declarator) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = size;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4635 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 221: /* direct_declarator: direct_declarator '[' ']'  */
#line 1419 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4650 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 222: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1430 "src/parse.yy"
    {
         (yyval.declarator) = NULL;
    }
#line 4658 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 223: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1434 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL)
                  d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4674 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 224: /* direct_declarator: direct_declarator '(' ')'  */
#line 1446 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4688 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 225: /* direct_declarator: direct_declarator '(' error ')'  */
#line 1456 "src/parse.yy"
    {
        (yyval.declarator) = NULL;
    }
#line 4696 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 226: /* pointer: '*'  */
#line 1464 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 4704 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 227: /* pointer: '*' type_qualifier_list  */
#line 1468 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 4714 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 228: /* pointer: '*' pointer  */
#line 1474 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4724 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 229: /* pointer: '*' type_qualifier_list pointer  */
#line 1480 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4735 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 230: /* reference: '&'  */
#line 1491 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 4743 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 231: /* parameter_type_list: parameter_list  */
#line 1498 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 4749 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 232: /* parameter_list: parameter_declaration  */
#line 1503 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4760 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 233: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 1510 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == NULL)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4773 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 234: /* parameter_list: error ','  */
#line 1519 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = NULL;
    }
#line 4782 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 235: /* parameter_declaration: declaration_specifiers declarator  */
#line 1527 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 4790 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 236: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 1531 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != NULL && (yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = NULL;
    }
#line 4803 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 237: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 1540 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != NULL && (yyvsp[0].declarator) != NULL)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = NULL;
    }
#line 4814 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 238: /* parameter_declaration: declaration_specifiers  */
#line 1547 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == NULL)
            (yyval.declaration) = NULL;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 4825 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 240: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 1565 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == NULL || (yyvsp[0].declarator) == NULL)
            (yyval.type) = NULL;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), NULL);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 4838 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 241: /* abstract_declarator: pointer  */
#line 1577 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 4846 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 243: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 1582 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4860 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 244: /* abstract_declarator: reference  */
#line 1592 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 4868 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 245: /* abstract_declarator: reference direct_abstract_declarator  */
#line 1596 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4882 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 246: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 1609 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 4888 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 247: /* direct_abstract_declarator: '[' ']'  */
#line 1611 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 4898 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 248: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 1617 "src/parse.yy"
      {
        int size;
        if ((yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = size;
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
      }
#line 4919 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 249: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 1634 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4934 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 250: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 1645 "src/parse.yy"
      {
          int size;
          if ((yyvsp[-3].declarator) != NULL && (yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              if (size < 0) {
                  Error((yylsp[-1]), "Array dimension must be non-negative.");
                  (yyval.declarator) = NULL;
              }
              else {
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = size;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              }
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4956 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 251: /* direct_abstract_declarator: '(' ')'  */
#line 1663 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 4962 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 252: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 1665 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
          (yyval.declarator) = d;
      }
#line 4972 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 253: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 1671 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4986 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 254: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 1681 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
      }
#line 5001 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 256: /* initializer: '{' initializer_list '}'  */
#line 1695 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 5007 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 257: /* initializer: '{' initializer_list ',' '}'  */
#line 1696 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 5013 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 258: /* initializer_list: initializer  */
#line 1701 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 5019 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 259: /* initializer_list: initializer_list ',' initializer  */
#line 1703 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 5034 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 260: /* pragma: TOKEN_PRAGMA  */
#line 1717 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 5042 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 261: /* attributed_statement: pragma attributed_statement  */
#line 1724 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != NULL)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
    }
#line 5054 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 275: /* statement: error ';'  */
#line 1748 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = NULL;
    }
#line 5063 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 276: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 1756 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
    }
#line 5071 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 277: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 1760 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].expr) != NULL &&
              lGetConstantInt((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              (yyval.stmt) = new CaseStmt(value, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
          }
          else
              (yyval.stmt) = NULL;
      }
#line 5085 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 278: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 1770 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 5091 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 279: /* start_scope: '{'  */
#line 1774 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 5097 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 280: /* end_scope: '}'  */
#line 1778 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 5103 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 281: /* compound_statement: '{' '}'  */
#line 1782 "src/parse.yy"
              { (yyval.stmt) = NULL; }
#line 5109 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 282: /* compound_statement: start_scope statement_list end_scope  */
#line 1783 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 5115 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 283: /* statement_list: attributed_statement  */
#line 1788 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5125 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 284: /* statement_list: statement_list attributed_statement  */
#line 1794 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 5139 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 285: /* expression_statement: ';'  */
#line 1806 "src/parse.yy"
          { (yyval.stmt) = NULL; }
#line 5145 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 286: /* expression_statement: expression ';'  */
#line 1807 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : NULL; }
#line 5151 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 287: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 1812 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, false, (yylsp[-4])); }
#line 5157 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 288: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1814 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 5163 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 289: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 1816 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, true, (yylsp[-4])); }
#line 5169 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 290: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 1818 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 5175 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 291: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 1820 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 5181 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 292: /* for_test: ';'  */
#line 1825 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 5187 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 293: /* for_test: expression ';'  */
#line 1827 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 5193 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 296: /* for_scope: TOKEN_FOR  */
#line 1836 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 5199 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 297: /* cfor_scope: TOKEN_CFOR  */
#line 1840 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 5205 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 298: /* foreach_scope: TOKEN_FOREACH  */
#line 1844 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 5211 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 299: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 1848 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 5217 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 300: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 1853 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::VaryingInt32->GetAsConstType());
    }
#line 5225 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 301: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 1859 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5231 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 302: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 1864 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::UniformInt64->GetAsConstType());
    }
#line 5239 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 303: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 1870 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 5248 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 304: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 1874 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 5257 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 305: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 1878 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 5266 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 306: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 1882 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 5275 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 307: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 1890 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5283 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 308: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 1894 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5291 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 309: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 1901 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 5300 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 310: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 1906 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == NULL) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != NULL)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 5315 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 311: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 1919 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5321 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 312: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 1923 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5327 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 313: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 1928 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 5333 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 314: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 1930 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 5339 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 315: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1932 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 5345 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 316: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 1934 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 5351 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 317: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 1936 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5359 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 318: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 1940 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5367 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 319: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 1944 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5375 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 320: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 1948 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5383 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 321: /* $@1: %empty  */
#line 1952 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5397 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 322: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 1962 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5419 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 323: /* $@2: %empty  */
#line 1980 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5434 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 324: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 1991 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5456 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 325: /* $@3: %empty  */
#line 2009 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != NULL)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 5465 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 326: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 2014 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 5474 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 327: /* $@4: %empty  */
#line 2020 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != NULL &&
             (expr = TypeCheck(expr)) != NULL &&
             (type = expr->GetType()) != NULL) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 5490 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 328: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2032 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();
     }
#line 5499 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 329: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2039 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5505 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 330: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2044 "src/parse.yy"
      { (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1])); }
#line 5511 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 331: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2046 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 5517 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 332: /* jump_statement: TOKEN_BREAK ';'  */
#line 2048 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 5523 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 333: /* jump_statement: TOKEN_RETURN ';'  */
#line 2050 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(NULL, (yylsp[-1])); }
#line 5529 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 334: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2052 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 5535 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 335: /* sync_statement: TOKEN_SYNC ';'  */
#line 2057 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 5541 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 336: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2062 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 5549 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 337: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2069 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 5557 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 338: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2076 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), NULL, (yylsp[-4]));
      }
#line 5565 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 339: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2080 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
      }
#line 5573 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 340: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2087 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
      }
#line 5581 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 346: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2102 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != NULL)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 5590 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 347: /* external_declaration: declaration  */
#line 2107 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != NULL)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 5600 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 349: /* $@5: %empty  */
#line 2117 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 5612 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;

  case 350: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2125 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == NULL)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == NULL) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 5633 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"
    break;


#line 5637 "/builddir/build/BUILD/ispc-1.16.1/redhat-linux-build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2151 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}


static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == NULL)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF)
        m->AddTypeDef(decl->name, decl->type, decl->pos);
    else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass,
                                      isInline, isNoInline, isVectorCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl->name, decl->type, decl->initExpr,
                                 isConst, decl->storageClass, decl->pos);
        }
    }
}


/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    m->symbolTable->PushScope();

    if (decl == NULL) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != NULL)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != NULL && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == NULL)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos,
                                     declarator->type, declarator->storageClass);
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = NULL;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, type);
    m->symbolTable->AddVariable(taskIndexSym);
    
    Symbol *taskCountSym = new Symbol("taskCount", pos, type);
    m->symbolTable->AddVariable(taskCountSym);
    
    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, type);
    m->symbolTable->AddVariable(taskIndexSym2);

    
    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage) {
    if (expr == NULL)
        return false;
    expr = TypeCheck(expr);
    if (expr == NULL)
        return false;
    expr = Optimize(expr);
    if (expr == NULL)
        return false;

    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == NULL) {
        Error(pos, "%s must be a compile-time constant.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == NULL) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        if (type->IsUnsignedType())
            *value = (int)ci->getZExtValue();
        else
            *value = (int)ci->getSExtValue();
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == NULL)
        return NULL;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != NULL)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != NULL) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != NULL);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
